//importing the required modules from d3.js to represent the world map
import { select, json ,geoPath, geoEquirectangular} from 'd3';
import {feature} from  'topojson';//importing feature from 'topojson' to convert the topojson data to geojson

const svg = select('svg');//selecting the svg element in the DOM


const projection1=geoEquirectangular();//instance for the  geoEquirectangular
const pathGeneratorfunction=geoPath().projection(projection1);//setting up the pathGenerator to projection using geopath() method

svg.append('path')//appending the path to the svg element
.attr('class','rectangle')//adding class name to the sphere to style it
.attr('d',pathGeneratorfunction({type:"Rectangle"}));//providing a rectangular shape to the map using pathGenerator method


json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')//invoking the json data
.then(data=>{
  const countries=feature(data,data.objects.countries);//selecting the countries from json data using feature method
  svg.selectAll('path').data(countries.features)//setting upt the data join for path
     .enter().append('path')//appending the new path to each element in the data
     .attr('class','country')//adding class name as country to style it.
     .attr('d',pathGeneratorfunction);//setting the 'd' attribute of path using pathGenerator based on countries

});









